
const { ccclass, property } = cc._decorator;

@ccclass
export default class Layer extends cc.Component {

    @property(cc.Node)
    animNode: cc.Node = null;

    _m_prefab: any = null;
    resArray: any[] = null;


    onLoad() {
        this.resArray = [];
    }

    start() {

    }

    setPrefab(prefab): void {
        this._m_prefab = prefab;
    }

    backEvent(): void {
        this.releaseRes();
        this.node.destroy();
        cc.log("remove")
    }

    releaseRes(): void {
        cc.assetManager.releaseAsset(this._m_prefab);
        for (let i = 0; i < this.resArray.length; i++) {
            cc.assetManager.releaseAsset(this.resArray[i]);
        }
        cc.log('release')
    }

    loadArm(): void {
        this.playLocalDragAnimationByName(this.animNode, 'texture/fankui', 'Sprite');

    }

    playLocalDragAnimationByName(node, url, armatureName) {
        if (!node) {
            return
        }
        cc.resources.loadDir(url, (err, assets) => {
            if (err) { return; }
            if (assets.length <= 0) { return; }

            for (let i = 0; i < assets.length; i++) {
                if (assets[i] instanceof cc.SpriteFrame) {
                    this.resArray.push(assets[i])
                }
            }

            let armatureDisplay = node.addComponent(dragonBones.ArmatureDisplay);
            for (var elem in assets) {
                if (assets[elem] instanceof dragonBones.DragonBonesAsset) {
                    if (armatureDisplay.dragonAsset != assets[elem]) {
                        armatureDisplay.dragonAsset = assets[elem];
                        this.resArray.push(assets[elem])
                    }
                }
                if (assets[elem] instanceof dragonBones.DragonBonesAtlasAsset) {
                    if (armatureDisplay.dragonAtlasAsset != assets[elem]) {
                        armatureDisplay.dragonAtlasAsset = assets[elem];
                        this.resArray.push(assets[elem])
                    }
                }
            }

            armatureDisplay.armatureName = "Sprite";
            armatureDisplay.playAnimation("Sprite", 1);
            armatureDisplay.timeScale = 1;
        })
    }

    /**
     * @method 通过Armature获取指定的object
     */
    getObjectByArmature(armatureArray: any[], armatureName: string): any {
        if (!armatureArray || armatureArray.length === 0) return null;
        for (let i = 0; i < armatureArray.length; i++) {
            if (armatureName === armatureArray[i].name) {
                return armatureArray[i];
            }
        }
    }
}
